Index: src/xplcommon/win32/LocalClientSocket.h
===================================================================
--- src/xplcommon/win32/LocalClientSocket.h	(revision 21)
+++ src/xplcommon/win32/LocalClientSocket.h	(revision 21)
@@ -0,0 +1,106 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#ifndef XPLCOMMON_WIN32_LOCALCLIENTSOCKET_H
+#define XPLCOMMON_WIN32_LOCALCLIENTSOCKET_H
+//------------------------------------------------------------------------------
+
+#include "LocalConnector.h"
+
+//------------------------------------------------------------------------------
+
+namespace xplcommon { namespace win32 {
+
+//------------------------------------------------------------------------------
+
+/**
+ * A client socket that connects to a named server socket locally,
+ * i.e. a named pipe.
+ *
+ * The server socket's name should be given. The name will be used as
+ * described for LocalServerSocket.
+ */
+class LocalClientSocket : public LocalSocket
+{
+private:
+    /**
+     * Create a named pipe for the given user-specified name.
+     */
+    static HANDLE create(const char* name, bool overlapped);
+
+    /**
+     * The local connector.
+     */
+    LocalConnector connector;
+
+public:
+    /**
+     * Construct the client socket with the given name.
+     */
+    LocalClientSocket(const char* name, Waiter* waiter = 0,
+                      size_t readingCapacity = DEFAULT_CAPACITY,
+                      size_t writingCapacity = DEFAULT_CAPACITY);
+
+    /**
+     * Get the connector.
+     */
+    LocalConnector& getConnector();
+};
+
+//------------------------------------------------------------------------------
+// Inline definitions
+//------------------------------------------------------------------------------
+
+inline LocalClientSocket::LocalClientSocket(const char* name, Waiter* waiter,
+                                            size_t readingCapacity,
+                                            size_t writingCapacity) :
+    LocalSocket(waiter, 0, readingCapacity, writingCapacity),
+    connector(this, name)
+{
+}
+
+//------------------------------------------------------------------------------
+
+inline LocalConnector& LocalClientSocket::getConnector()
+{
+    return connector;
+}
+
+//------------------------------------------------------------------------------
+
+} /* namespace xplcommon::win32 */ } /* namespace xplcommon */
+
+//------------------------------------------------------------------------------
+#endif // XPLCOMMON_WIN32_LOCALCLIENTSOCKET_H
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplcommon/win32/LocalConnector.cc
===================================================================
--- src/xplcommon/win32/LocalConnector.cc	(revision 21)
+++ src/xplcommon/win32/LocalConnector.cc	(revision 21)
@@ -0,0 +1,71 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+//------------------------------------------------------------------------------
+
+#include "LocalConnector.h"
+
+#include <cstdio>
+
+//------------------------------------------------------------------------------
+
+using xplcommon::win32::LocalConnector;
+
+//------------------------------------------------------------------------------
+
+bool LocalConnector::connect()
+{
+    printf("LocalConnector::connect0\n");
+    if (connected) return true;
+
+    printf("LocalConnector::connect3\n");
+
+    HANDLE handle = CreateFile(name, GENERIC_READ|GENERIC_WRITE,
+                               0, 0, OPEN_EXISTING,
+                               FILE_FLAG_NO_BUFFERING | FILE_FLAG_OVERLAPPED, 0);
+    printf("LocalConnector::connect4\n");
+    if (handle!=0) {
+        printf("LocalConnector::connect5\n");
+        socket.handle = handle;
+        connected = true;
+        return true;
+    } else {
+        printf("LocalConnector::connect6\n");
+        socket.setErrorCode(GetLastError());
+        return false;
+    }
+}
+
+//------------------------------------------------------------------------------
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplcommon/win32/LocalConnector.h
===================================================================
--- src/xplcommon/win32/LocalConnector.h	(revision 21)
+++ src/xplcommon/win32/LocalConnector.h	(revision 21)
@@ -0,0 +1,135 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#ifndef XPLCOMMON_WIN32_LOCALCONNECTOR_H
+#define XPLCOMMON_WIN32_LOCALCONNECTOR_H
+//------------------------------------------------------------------------------
+
+#include "Completer.h"
+
+#include "LocalSocket.h"
+
+//------------------------------------------------------------------------------
+
+namespace xplcommon { namespace win32 {
+
+//------------------------------------------------------------------------------
+
+class LocalConnector : public FailableReference<LocalConnector>
+{
+private:
+    /**
+     * The local socket to connect on behalf of which (it should
+     * actually be a LocalClientSocket.
+     */
+    LocalSocket& socket;
+
+    /**
+     * The name of the pipe to connect to.
+     */
+    char name[256];
+
+    /**
+     * Indicate if we are connected.
+     */
+    bool connected;
+
+protected:
+    /**
+     * Construct the connector.
+     */
+    LocalConnector(LocalSocket* socket, const char* name);
+
+public:
+    /**
+     * Connect to an address properly set up.
+     *
+     * If the connection succeeds immediately, it indicates success.
+     *
+     * If the connection does not succeed, because it would block, it
+     * sets up the socket to wait for the connection to succeed, and
+     * returns failure.
+     *
+     * If the connection fails for another reason, the error code is
+     * set, and false is returned.
+     */
+    bool connect();
+
+private:
+    /**
+     * Get the failable object.
+     */
+    const ::xplcommon::Failable& getFailable() const;
+
+    /**
+     * Get the failable object.
+     */
+    ::xplcommon::Failable& getFailable();
+
+    friend class FailableReference<LocalConnector>;
+    friend class LocalClientSocket;
+};
+
+//------------------------------------------------------------------------------
+// Inline definitions
+//------------------------------------------------------------------------------
+
+inline LocalConnector::LocalConnector(LocalSocket* socket, const char* name) :
+    socket(*socket),
+    connected(false)
+{
+    LocalSocket::setupName(this->name, name);
+}
+
+//------------------------------------------------------------------------------
+
+inline const ::xplcommon::Failable& LocalConnector::getFailable() const
+{
+    return socket;
+}
+
+//------------------------------------------------------------------------------
+
+inline ::xplcommon::Failable& LocalConnector::getFailable()
+{
+    return socket;
+}
+
+//------------------------------------------------------------------------------
+
+} /* namespace xplcommon::win32 */ } /* namespace xplcommon */
+
+//------------------------------------------------------------------------------
+#endif // XPLCOMMON_WIN32_LOCALCONNECTOR_H
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplcommon/win32/LocalServerSocket.h
===================================================================
--- src/xplcommon/win32/LocalServerSocket.h	(revision 21)
+++ src/xplcommon/win32/LocalServerSocket.h	(revision 21)
@@ -0,0 +1,98 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#ifndef XPLCOMMON_WIN32_LOCALSERVERSOCKET_H
+#define XPLCOMMON_WIN32_LOCALSERVERSOCKET_H
+//------------------------------------------------------------------------------
+
+#include "LocalServerSocketBase.h"
+
+#include "LocalAcceptor.h"
+
+//------------------------------------------------------------------------------
+
+namespace xplcommon { namespace win32 {
+
+//------------------------------------------------------------------------------
+
+/**
+ * A server socket that works locally, i.e. a named pipe.
+ *
+ * It is identified by a name that should be unique for a user. The
+ * actual pipe will be created with the name \\.\pipe\<name>.
+ */
+class LocalServerSocket : public LocalServerSocketBase
+{
+private:
+    /**
+     * The acceptor to use.
+     */
+    LocalAcceptor acceptor;
+
+public:
+    /**
+     * Construct the socket.
+     */
+    LocalServerSocket(const char* name, Waiter* waiter = 0);
+
+    /**
+     * Get the acceptor.
+     */
+    LocalAcceptor& getAcceptor();
+};
+
+//------------------------------------------------------------------------------
+// Inline definitions
+//------------------------------------------------------------------------------
+
+inline LocalServerSocket::LocalServerSocket(const char* name, Waiter* waiter) :
+    LocalServerSocketBase(waiter),
+    acceptor(this, name)
+{
+}
+
+//------------------------------------------------------------------------------
+
+inline LocalAcceptor& LocalServerSocket::getAcceptor()
+{
+    return acceptor;
+}
+
+//------------------------------------------------------------------------------
+
+} /* namespace xplcommon::win32 */ } /* namespace xplcommon */
+
+//------------------------------------------------------------------------------
+#endif // XPLCOMMON_WIN32_LOCALSERVERSOCKET_H
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplcommon/win32/LocalServerSocketBase.cc
===================================================================
--- src/xplcommon/win32/LocalServerSocketBase.cc	(revision 21)
+++ src/xplcommon/win32/LocalServerSocketBase.cc	(revision 21)
@@ -0,0 +1,83 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+//------------------------------------------------------------------------------
+
+#include "LocalServerSocketBase.h"
+
+#include "LocalSocket.h"
+
+//------------------------------------------------------------------------------
+
+using xplcommon::win32::LocalServerSocketBase;
+
+//------------------------------------------------------------------------------
+
+bool LocalServerSocketBase::createNamedPipe(const char* name)
+{
+    handle = CreateNamedPipe(name, PIPE_ACCESS_DUPLEX |
+                             ((waiter==0) ? 0 : FILE_FLAG_OVERLAPPED),
+                             PIPE_TYPE_BYTE | PIPE_READMODE_BYTE,
+                             PIPE_UNLIMITED_INSTANCES,
+                             BufferedStream::DEFAULT_CAPACITY,
+                             BufferedStream::DEFAULT_CAPACITY,
+                             0, 0);
+    if (handle==0) {
+        setErrorCode(GetLastError());
+    }
+    return handle!=0;
+}
+
+//------------------------------------------------------------------------------
+
+bool LocalServerSocketBase::connectNamedPipe(Overlapped* overlapped)
+{
+    bool result = LocalSocket::connectNamedPipe(handle, overlapped);
+    if (!result && overlapped==0) {
+        setErrorCode(GetLastError());
+    }
+    return result;
+}
+
+//------------------------------------------------------------------------------
+
+HANDLE LocalServerSocketBase::releaseHandle()
+{
+    HANDLE h = handle;
+    handle = 0;
+    return h;
+}
+
+//------------------------------------------------------------------------------
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplcommon/win32/LocalServerSocketBase.h
===================================================================
--- src/xplcommon/win32/LocalServerSocketBase.h	(revision 21)
+++ src/xplcommon/win32/LocalServerSocketBase.h	(revision 21)
@@ -0,0 +1,106 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#ifndef XPLCOMMON_WIN32_LOCALSERVERSOCKETBASE_H
+#define XPLCOMMON_WIN32_LOCALSERVERSOCKETBASE_H
+//------------------------------------------------------------------------------
+
+#include "Overlappable.h"
+
+//------------------------------------------------------------------------------
+
+namespace xplcommon { namespace win32 {
+
+//------------------------------------------------------------------------------
+
+class Overlapped;
+
+//------------------------------------------------------------------------------
+
+/**
+ * Base class for a local server socket. This is here only to allow
+ * for a more efficient implementation of LocalAcceptor.
+ */
+class LocalServerSocketBase : public Overlappable
+{
+protected:
+    /**
+     * Construct the server socket base.
+     */
+    LocalServerSocketBase(Waiter* waiter);
+
+    /**
+     * Create a new named pipe with the proper settings. The handle of
+     * this object will be set to the created handle.
+     *
+     * @param name the name of the pipe to create. It should be the
+     * final name, not the user-given one.
+     *
+     * @return whether the pipe could be created
+     */
+    bool createNamedPipe(const char* name);
+
+    /**
+     * Connect the named pipe with the current handle of this object.
+     *
+     * @return whether the connection succeeded. If not, it may be a
+     * failure, which is then indicated, or it may be an overlapped
+     * operation which needs to wait.
+     */
+    bool connectNamedPipe(Overlapped* overlapped);
+
+    /**
+     * Get the handle and clear it.
+     */
+    HANDLE releaseHandle();
+
+    friend class LocalAcceptor;
+};
+
+//------------------------------------------------------------------------------
+// Inline definitions
+//------------------------------------------------------------------------------
+
+inline LocalServerSocketBase::LocalServerSocketBase(Waiter* waiter) :
+    Overlappable(waiter)
+{
+}
+
+//------------------------------------------------------------------------------
+
+} /* namespace xplcommon::win32 */ } /* namespace xplcommon */
+
+//------------------------------------------------------------------------------
+#endif // XPLCOMMON_WIN32_LOCALSERVERSOCKETBASE_H
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplcommon/win32/LocalSocket.h
===================================================================
--- src/xplcommon/win32/LocalSocket.h	(revision 21)
+++ src/xplcommon/win32/LocalSocket.h	(revision 21)
@@ -0,0 +1,156 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#ifndef XPLCOMMON_WIN32_LOCALSOCKET_H
+#define XPLCOMMON_WIN32_LOCALSOCKET_H
+//------------------------------------------------------------------------------
+
+#include "BufferedStream.h"
+
+#include "Overlapped.h"
+
+#include <cstdio>
+
+//------------------------------------------------------------------------------
+
+namespace xplcommon { namespace win32 {
+
+//------------------------------------------------------------------------------
+
+/**
+ * Basically a different name for a buffered stream.
+ */
+class LocalSocket : public BufferedStream
+{
+public:
+    /**
+     * Create a concrete pipe name from the given user-specified name.
+     *
+     * @param dest the destination buffer, which should be at least
+     * 256 bytes long.
+     */
+    static void setupName(char* dest, const char* name);
+
+    /**
+     * Create a new named pipe with the proper settings. The handle
+     * will be returned on successful creation.
+     *
+     * @param name the name of the pipe to create. It should be the
+     * final name, not the user-given one.
+     *
+     * @return the handle if the pipe could be created.
+     */
+    static HANDLE createNamedPipe(const char* name, bool overlapped);
+
+    /**
+     * Connect the named pipe with the given handle.
+     *
+     * @return true if the connection is established. If overlapped is
+     * 0 and false is returned, it has failed. If overlapped is not 0,
+     * the failer status of the Failable associated with the
+     * Overlapped instance provides failure information.
+     */
+    static bool connectNamedPipe(HANDLE handle, Overlapped* overlapped);
+
+protected:
+    /**
+     * Construct the local socket
+     */
+    LocalSocket(Waiter* waiter = 0, HANDLE handle = 0,
+                size_t readingCapacity = DEFAULT_CAPACITY,
+                size_t writingCapacity = DEFAULT_CAPACITY);
+
+
+protected:
+    /**
+     * Connect the named pipe with the current handle of this object.
+     *
+     * @return whether the connection succeeded. If not, it may be a
+     * failure, which is then indicated, or it may be an overlapped
+     * operation which needs to wait.
+     */
+    bool connect(Overlapped* overlapped);
+
+    friend class LocalAcceptor;
+    friend class LocalConnector;
+};
+
+//------------------------------------------------------------------------------
+// Inline definitions
+//------------------------------------------------------------------------------
+
+inline void LocalSocket::setupName(char* dest, const char* name)
+{
+    snprintf(dest, 256, "\\\\.\\pipe\\%s", name);
+}
+
+//------------------------------------------------------------------------------
+
+inline bool LocalSocket::connectNamedPipe(HANDLE handle, Overlapped* overlapped)
+{
+    OVERLAPPED* ol = (overlapped==0) ? 0 : overlapped->get();
+    bool result = ConnectNamedPipe(handle, ol);
+    if (overlapped!=0) {
+        DWORD dummy = 0;
+        result = overlapped->getResult(dummy, handle);
+    }
+    return result;
+}
+
+//------------------------------------------------------------------------------
+
+inline LocalSocket::LocalSocket(Waiter* waiter, HANDLE handle,
+                                size_t readingCapacity, size_t writingCapacity):
+    BufferedStream(waiter, handle, readingCapacity, writingCapacity)
+{
+}
+
+//------------------------------------------------------------------------------
+
+inline bool LocalSocket::connect(Overlapped* overlapped)
+{
+    bool result = connectNamedPipe(handle, overlapped);
+    if (!result && overlapped==0) {
+        setErrorCode(GetLastError());
+    }
+    return result;
+}
+
+//------------------------------------------------------------------------------
+
+} /* namespace xplcommon::win32 */ } /* namespace xplcommon */
+
+//------------------------------------------------------------------------------
+#endif // XPLCOMMON_WIN32_LOCALSOCKET_H
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplcommon/win32/Makefile.am
===================================================================
--- src/xplcommon/win32/Makefile.am	(revision 20)
+++ src/xplcommon/win32/Makefile.am	(revision 21)
@@ -6,11 +6,30 @@
 	Overlapped.cc		\
 	Waiter.cc		\
-	WaitableEvent.cc
+	BufferedStream.cc	\
+	ReadingBuffer.cc	\
+	WritingBuffer.cc	\
+	LocalAcceptor.cc	\
+	LocalServerSocketBase.cc\
+	LocalConnector.cc	\
+	LocalClientSocket.cc
 
 include_xplcommon_win32dir=$(includedir)/xplcommon/win32
 include_xplcommon_win32_HEADERS=\
 	Thread.h		\
+	EventFailable.h		\
 	Event.h			\
 	Overlapped.h		\
 	Waiter.h		\
-	WaitableEvent.h
+	WaitableEvent.h		\
+	Overlappable.h		\
+	Completer.h		\
+	StreamBuffer.h		\
+	BufferedStream.h	\
+	ReadingBuffer.h		\
+	WritingBuffer.h		\
+	LocalSocket.h		\
+	LocalAcceptor.h		\
+	LocalServerSocketBase.h	\
+	LocalServerSocket.h	\
+	LocalConnector.h	\
+	LocalClientSocket.h
